原文链接: https://leetcode-cn.com/problems/best-time-to-buy-and-sell-stock-iii
英文原文
You are given an array prices
where prices[i]
is the price of a given stock on the ith
day.
Find the maximum profit you can achieve. You may complete at most two transactions.
Note: You may not engage in multiple transactions simultaneously (i.e., you must sell the stock before you buy again).
Example 1:
Input: prices = [3,3,5,0,0,3,1,4] Output: 6 Explanation: Buy on day 4 (price = 0) and sell on day 6 (price = 3), profit = 3-0 = 3. Then buy on day 7 (price = 1) and sell on day 8 (price = 4), profit = 4-1 = 3.
Example 2:
Input: prices = [1,2,3,4,5] Output: 4 Explanation: Buy on day 1 (price = 1) and sell on day 5 (price = 5), profit = 5-1 = 4. Note that you cannot buy on day 1, buy on day 2 and sell them later, as you are engaging multiple transactions at the same time. You must sell before buying again.
Example 3:
Input: prices = [7,6,4,3,1] Output: 0 Explanation: In this case, no transaction is done, i.e. max profit = 0.
Example 4:
Input: prices = [1] Output: 0
Constraints:
1 <= prices.length <= 105
0 <= prices[i] <= 105
中文题目
给定一个数组,它的第 i
个元素是一支给定的股票在第 i
天的价格。
设计一个算法来计算你所能获取的最大利润。你最多可以完成 两笔 交易。
注意:你不能同时参与多笔交易(你必须在再次购买前出售掉之前的股票)。
示例 1:
输入:prices = [3,3,5,0,0,3,1,4] 输出:6 解释:在第 4 天(股票价格 = 0)的时候买入,在第 6 天(股票价格 = 3)的时候卖出,这笔交易所能获得利润 = 3-0 = 3 。 随后,在第 7 天(股票价格 = 1)的时候买入,在第 8 天 (股票价格 = 4)的时候卖出,这笔交易所能获得利润 = 4-1 = 3 。
示例 2:
输入:prices = [1,2,3,4,5] 输出:4 解释:在第 1 天(股票价格 = 1)的时候买入,在第 5 天 (股票价格 = 5)的时候卖出, 这笔交易所能获得利润 = 5-1 = 4 。 注意你不能在第 1 天和第 2 天接连购买股票,之后再将它们卖出。 因为这样属于同时参与了多笔交易,你必须在再次购买前出售掉之前的股票。
示例 3:
输入:prices = [7,6,4,3,1] 输出:0 解释:在这个情况下, 没有交易完成, 所以最大利润为 0。
示例 4:
输入:prices = [1] 输出:0
提示:
1 <= prices.length <= 105
0 <= prices[i] <= 105
通过代码
高赞题解
一天结束时,可能有持股、可能未持股、可能卖出过1次、可能卖出过2次、也可能未卖出过
所以定义状态转移数组dp[天数][当前是否持股][卖出的次数]
具体一天结束时的6种状态:
- 未持股,未卖出过股票:说明从未进行过买卖,利润为0
dp[i][0][0]=0
- 未持股,卖出过1次股票:可能是今天卖出,也可能是之前卖的(昨天也未持股且卖出过)
dp[i][0][1]=max(dp[i-1][1][0]+prices[i],dp[i-1][0][1])
- 未持股,卖出过2次股票:可能是今天卖出,也可能是之前卖的(昨天也未持股且卖出过)
dp[i][0][2]=max(dp[i-1][1][1]+prices[i],dp[i-1][0][2])
- 持股,未卖出过股票:可能是今天买的,也可能是之前买的(昨天也持股)
dp[i][1][0]=max(dp[i-1][0][0]-prices[i],dp[i-1][1][0])
- 持股,卖出过1次股票:可能是今天买的,也可能是之前买的(昨天也持股)
dp[i][1][1]=max(dp[i-1][0][1]-prices[i],dp[i-1][1][1])
- 持股,卖出过2次股票:最多交易2次,这种情况不存在
dp[i][1][2]=float('-inf')
根据这些状态即可轻松写出代码
class Solution:
def maxProfit(self, prices):
if prices==[]:
return 0
length=len(prices)
#结束时的最高利润=[天数][是否持有股票][卖出次数]
dp=[ [[0,0,0],[0,0,0] ] for i in range(0,length) ]
#第一天休息
dp[0][0][0]=0
#第一天买入
dp[0][1][0]=-prices[0]
# 第一天不可能已经有卖出
dp[0][0][1] = float('-inf')
dp[0][0][2] = float('-inf')
#第一天不可能已经卖出
dp[0][1][1]=float('-inf')
dp[0][1][2]=float('-inf')
for i in range(1,length):
#未持股,未卖出过,说明从未进行过买卖
dp[i][0][0]=0
#未持股,卖出过1次,可能是今天卖的,可能是之前卖的
dp[i][0][1]=max(dp[i-1][1][0]+prices[i],dp[i-1][0][1])
#未持股,卖出过2次,可能是今天卖的,可能是之前卖的
dp[i][0][2]=max(dp[i-1][1][1]+prices[i],dp[i-1][0][2])
#持股,未卖出过,可能是今天买的,可能是之前买的
dp[i][1][0]=max(dp[i-1][0][0]-prices[i],dp[i-1][1][0])
#持股,卖出过1次,可能是今天买的,可能是之前买的
dp[i][1][1]=max(dp[i-1][0][1]-prices[i],dp[i-1][1][1])
#持股,卖出过2次,不可能
dp[i][1][2]=float('-inf')
return max(dp[length-1][0][1],dp[length-1][0][2],0)
统计信息
通过次数 | 提交次数 | AC比率 |
---|---|---|
139787 | 258969 | 54.0% |
提交历史
提交时间 | 提交结果 | 执行时间 | 内存消耗 | 语言 |
---|
相似题目
题目 | 难度 |
---|---|
买卖股票的最佳时机 | 简单 |
买卖股票的最佳时机 II | 中等 |
买卖股票的最佳时机 IV | 困难 |
三个无重叠子数组的最大和 | 困难 |